﻿/*  Copyright © exc-jdbi 2021

    © Finite Field  2012

    © Finite Field  2012 is Free and Opensource Software
    
    www.vb-paradise.de/index.php/User/23082-exc-jdbi/
 
    github.com/exc-jdbi
*/


namespace FiniteFields
{
  public partial class FiniteField
  {
    /// <summary>
    /// Gibt die Ordnung an. 
    /// "Number of Elements"
    /// </summary>
    public readonly int Order = -1;

    /// <summary>
    /// Gibt den Exponenten zum Generator an.
    /// "Degree"
    /// </summary>
    public readonly int Exponent = -1;

    /// <summary>
    /// Gibt den Generatorwert an.
    /// <para></para>
    /// Vorzugsweise eine Prime !
    /// "Characteristic"
    /// </summary>
    public readonly int Generator = -1;

    /// <summary>
    /// Gibt den Wert der Irreducible Polynomial an.
    /// "Primitive polynomials"
    /// </summary>
    public readonly int Polynomial = -1;

    /// <summary>
    /// Maximale Tablegrösse die noch ausgegeben wird.
    /// </summary>
    private const int MAX_TABLE = 256;


    private int MValue = 0;
    /// <summary>
    /// Gibt den Value der Finite Field zurück.
    /// </summary>
    public int Value
    {
      get => this.MValue;
      set => this.MValue = ExtMod(value, this.Order);
    }
  }
}
